.docker_login:
  script:
    - echo "${REGISTRY_PASSWORD}" |
      docker login -u "${REGISTRY_USER}"
                   --password-stdin
                   "${REGISTRY}"

.define_image_tag:
  script:
    - if [[ -n "${CI_COMMIT_TAG}" ]]; then
        IMAGE_TAG="${CI_COMMIT_TAG}";
      elif [[ "${CI_COMMIT_REF_SLUG}" == "${CI_DEFAULT_BRANCH}" ]]; then
        IMAGE_TAG="latest";
      fi

.docker_build:
  script:
    - !reference [.define_image_tag, script]
    - docker build
        -t "${IMAGE_NAME}:${IMAGE_TAG}"
        -f "${DOCKER_DIRECTORY}/${DOCKER_FILENAME}"
        ${ROOT_DOCKER_CONTEXT} && echo "." || echo "${DOCKER_DIRECTORY}"

.docker_push:
  script:
    - !reference [.define_image_tag, script]
    - docker push "${IMAGE_NAME}:${IMAGE_TAG}"

.docker_push_dind:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  variables:
    DOCKER_DIRECTORY: "."
    DOCKER_FILENAME: "Dockerfile"
    ROOT_DOCKER_CONTEXT: true
    REGISTRY: "${CI_REGISTRY}"
    REGISTRY_USER: "gitlab-ci-token"
    REGISTRY_PASSWORD: "${CI_JOB_TOKEN}"
    IMAGE_NAME: "${CI_REGISTRY_IMAGE}"
    IMAGE_TAG: "${CI_COMMIT_REF_SLUG}"
  script:
    - !reference [.docker_login, script]
    - !reference [.docker_build, script]
    - !reference [.docker_push, script]
  tags:
    - docker
